#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#include	<math.h>

void help()
{
	printf("\n ******** Help ********\n");
	printf(" hn [+|-] m (n=1 to 4 )  ... Horizontal\n");
	printf(" ha [+|-] m              ... All Horizontal\n");
	printf(" vn [+|-] m (n=1 to 4)   ... Vertical\n");
	printf(" va [+|-] m              ... All Vertical\n");
	printf(" mult  n  ... horiz entry(fst, fth) mult of \n");
	printf(" d  [+|-] m  ... Dotclock\n");
	printf(" h  ... Help\n");
	printf(" q  ... quit\n");
	printf("\n");
}

int	main()
{
	float	dotclk=85;
	float	hfreq=65;
	float	hblnk=3.6;
	float	refrate = 120;
	float	tmpf;
	int		h[4],v[4],i;
	int		hsyncgard1=32;
	int		hsyncgard2=48;
	int		vsyncgard=3;
	int		vsync=10;
	int		multof	= 64;
	int		yx_ratio = 75;
	int		tmpi;
	char	buf[80],obuf[80],*p1,*p2;

	printf("Enter DotClk in Mhz (%f) : ",dotclk);
	if(gets(buf))sscanf(buf,"%f",&dotclk);

	printf("Enter Max Horizontal Frequency in Khz (%f) : ",hfreq);
	if(gets(buf))sscanf(buf,"%f",&hfreq);

	printf("Enter Min Horizontal Blank time in microsecond (%f) : ",hblnk);
	if(gets(buf))sscanf(buf,"%f",&hblnk);

	printf("Enter Horizontal gard time before sync in clk (%d) : ",hsyncgard1);
	if(gets(buf))sscanf(buf,"%d",&hsyncgard1);

	printf("Enter Horizontal gard time after sync in clk (%d) : ",hsyncgard2);
	if(gets(buf))sscanf(buf,"%d",&hsyncgard2);

	printf("Horizontal Entry(fst,fth) is Mult of ? (%d) : ",multof);
	if(gets(buf))sscanf(buf,"%d",&multof);

	printf("Enter Vertical gard time before sync in clk (%d) : ",vsyncgard);
	if(gets(buf))sscanf(buf,"%d",&vsyncgard);

	printf("Enter Vertical sync time in clk (%d) : ",vsync);
	if(gets(buf))sscanf(buf,"%d",&vsync);

	printf("Enter vert/horiz ratio in %% (%d) : ",yx_ratio);
	if(gets(buf))sscanf(buf,"%d",&yx_ratio);

	printf("Enter Max refresh rate (%f) : ",refrate);
	if(gets(buf))sscanf(buf,"%f",&refrate);

	printf("\nCalculating...\n\n");

	i = dotclk*1000/hfreq;
	h[3] = ( ( i / multof )+ 1) * multof;

	i = hblnk * dotclk;
	h[0] = h[3]-((i/multof) +1)*multof;

	hsyncgard1-=hsyncgard1%8;
	hsyncgard2-=hsyncgard2%8; 

	h[1] = h[0] + hsyncgard1;
	h[2] = h[3] - hsyncgard2;


	v[0] = (h[0] * yx_ratio) / 100;
	v[1] = v[0] + vsyncgard;
	v[2] = v[1] + vsync;
	v[3] = v[0] * 1.05;

	while(1){
		printf("\n");

		printf("# Dotclk = %f Mhz\n",dotclk);
		printf("# Horizontal Freq = %f Khz\n",dotclk/h[3]*1000);
		printf("# Horizontal Blank = %f microsec\n",(h[3]-h[0])/dotclk);
		printf("# Horizontal sync time = %f microsec\n",(h[2]-h[1])/dotclk);
		printf("# Refresh Rate = %f Hz \n",dotclk*1000000/v[3]/h[3]);

		if ( dotclk / h[3] * 1000 > hfreq )
		printf("\n\a#***** Horize Freq > max(%f) ... decre dotclk or incre 4'th  of htiming or something\n",hfreq);

		if ( (h[3]-h[0]) / dotclk < hblnk)
		printf("\n\a#***** Horize Blank < min(%f) ... decre dotclk or decre 1'st  of htiming or incre 4'th  or something\n",hblnk);

		if ( dotclk*1000000/v[3]/h[3] > refrate )
		printf("\n\a#***** Refresh rate > max(%f) ... decre dotclk or incre all htiming or something\n",refrate);

		if(h[0]>=h[1]) printf("\n\a#***** Horiz timing1 >= timing2\n");
		if(h[1]>=h[2]) printf("\n\a#***** Horiz timing2 >= timing3\n");
		if(h[2]>=h[3]) printf("\n\a#***** Horiz timing3 >= timing4\n");

		if(v[0]>=v[1]) printf("\n\a#***** Vert timing1 >= timing2\n");
		if(v[1]>=v[2]) printf("\n\a#***** Vert timing2 >= timing3\n");
		if(v[2]>=v[3]) printf("\n\a#***** Vert timing3 >= timing4\n");

		printf("\nDotClock  %f\n",dotclk);
		printf("HTimings %5d %5d %5d %5d\n",h[0],h[1],h[2],h[3]);
		printf("VTimings %5d %5d %5d %5d\n",v[0],v[1],v[2],v[3]);

		while(1){
			printf("\nh for help (%s) : ",obuf);
			gets(buf);
			for(i=0;i<strlen(buf);i++){	obuf[i]=buf[i]=tolower(buf[i]);}
			if(i==0)break;
			obuf[i]='\0';
			if(strcmp(buf,"h")==0){help();continue;}
			if(strcmp(buf,"q")==0) exit(0);
			break;
		}

		p1 = strtok(buf	," ");
		if (p1) p2 = strtok(NULL," ");
		else continue;
/*---------------------------*/
		if(strcmp(p1,"ha")==0){
			if(p2){
				sscanf(p2,"%d",&tmpi);
				tmpi*=multof;
				h[0]+=tmpi;
				h[1]+=tmpi;
				h[2]+=tmpi;
				h[3]+=tmpi;
				v[0] = (h[0] * yx_ratio) / 100;
				v[1] = v[0] + vsyncgard;
				v[2] = v[1] + vsync;
				v[3] = v[0] * 1.05;
			}
			continue;
		}
/*---------------------------*/
		if(strcmp(p1,"h1")==0){
			if(p2){
				sscanf(p2,"%d",&tmpi);
				tmpi*=multof;
				h[0]+=tmpi;
				h[1]+=tmpi;
				v[0] = (h[0] * yx_ratio) / 100;
				v[1] = v[0] + vsyncgard;
				v[2] = v[1] + vsync;
				v[3] = v[0] * 1.05;
			}
			continue;
		}
/*---------------------------*/
		if(strcmp(p1,"h2")==0){
			if(p2){
				sscanf(p2,"%d",&tmpi);
				tmpi*=8;
				h[1]+=tmpi;
			}
			continue;
		}
/*---------------------------*/
		if(strcmp(p1,"h3")==0){
			if(p2){
				sscanf(p2,"%d",&tmpi);
				tmpi*=8;
				h[2]+=tmpi;
			}
			continue;
		}
/*---------------------------*/
		if(strcmp(p1,"h4")==0){
			if(p2){
				sscanf(p2,"%d",&tmpi);
				tmpi*=multof;
				h[3]+=tmpi;
				h[2]+=tmpi;
			}
			continue;
		}
/*---------------------------*/
		if(strcmp(p1,"va")==0){
			if(p2){
				sscanf(p2,"%d",&tmpi);
				v[0]+=tmpi;
				v[1]+=tmpi;
				v[2]+=tmpi;
				v[3]+=tmpi;
			}
			continue;
		}
/*---------------------------*/
		if(strcmp(p1,"v1")==0){
			if(p2){
				sscanf(p2,"%d",&tmpi);
				v[0]+=tmpi;
				v[1]=v[0]+vsyncgard;
				v[2]=v[1]+vsync;
			}
			continue;
		}
/*---------------------------*/
		if(strcmp(p1,"v2")==0){
			if(p2){
				sscanf(p2,"%d",&tmpi);
				v[1]+=tmpi;
				v[2]=v[1]+vsync;
			}
			continue;
		}
/*---------------------------*/
		if(strcmp(p1,"v3")==0){
			if(p2){
				sscanf(p2,"%d",&tmpi);
				v[2]+=tmpi;
			}
			continue;
		}
/*---------------------------*/
		if(strcmp(p1,"v4")==0){
			if(p2){
				sscanf(p2,"%d",&tmpi);
				v[3]+=tmpi;
			}
			continue;
		}
/*---------------------------*/
		if(strcmp(p1,"d")==0){
			if(p2){
				sscanf(p2,"%f",&tmpf);
				dotclk+=tmpf;
			}
			continue;
		}
/*---------------------------*/
		if(strcmp(p1,"mult")==0){
			if(p2){
				sscanf(p2,"%d",&multof);
				h[0]-=(h[0]%multof);
				h[1] = h[0] + hsyncgard1;
				h[3]-=(h[3]%multof);
				h[2] = h[3] - hsyncgard2;
				v[0] = (h[0] * yx_ratio) / 100;
				v[1] = v[0] + vsyncgard;
				v[2] = v[1] + vsync;
				v[3] = v[0] * 1.05;
			}
			continue;
		}

		printf("\a");
	}
	return 0;
}